namespace $safeprojectname$
{
    using System;
    using System.Collections.Generic;
    using System.Text;
    using System.Diagnostics;
    using System.Runtime.InteropServices;
    using Outlook = Microsoft.Office.Interop.Outlook;
    using Office = Microsoft.Office.Core;
    using System.Windows.Forms;
    using Microsoft.Office.Tools;

    class InspWrap
    {
        public bool HTML;
        public bool PT;
        public bool RTF;

        private Outlook.Inspector m_Insp = null;
        private Outlook.InspectorClass m_InspClass = null;

        private Outlook.MailItem m_Mail = null;
        private Outlook.AppointmentItem m_Appt = null;

        private TimeTravelFormRegionWrapper m_Region;

        private Office.IRibbonUI m_Ribbon;

        private int m_ID = 0;

        private bool m_Startup = false;

        private bool m_blnKilled = false;

        private System.Collections.SortedList m_WrapperClass = null;

        private Outlook.ItemEvents_Event m_events;
        private Outlook.ItemEvents_Event m_ApptEvents;

        private Office.CustomTaskPane m_Pane;

        public Office.IRibbonUI Ribbon
        {
            get
            {
                return m_Ribbon;
            }

            set
            {
                m_Ribbon = value;
            }
        }

        public Office.CustomTaskPane TaskPane
        {
            get
            {
                return m_Pane;
            }

            set
            {
                m_Pane = value;

                if (m_Pane != null)
                {
                    // hook up the CTP event
                    m_Pane.VisibleStateChange += new Office._CustomTaskPaneEvents_VisibleStateChangeEventHandler(m_Pane_VisibleStateChange);
                    m_Pane.DockPositionStateChange += new Microsoft.Office.Core._CustomTaskPaneEvents_DockPositionStateChangeEventHandler(m_Pane_DockPositionStateChange);
                }
            }
        }

        public TimeTravelFormRegionWrapper Region
        {
            get
            {
                return m_Region;
            }

            set
            {
                m_Region = value;
            }
        }

        public System.Collections.SortedList WrapperClass
        {
            get
            {
                return m_WrapperClass;
            }

            set
            {
                m_WrapperClass = value;
            }
        }

        public Outlook.Inspector Inspector
        {
            get
            {
                return m_Insp;
            }

            set
            {
                m_Insp = value;

                m_InspClass = (Outlook.InspectorClass)m_Insp;

                // hook up the Inspector Close event handler
                m_InspClass.InspectorEvents_Event_Close += new Microsoft.Office.Interop.Outlook.InspectorEvents_CloseEventHandler(m_Insp_Close);

                // hook up the Inspector Activate event handler
                m_InspClass.InspectorEvents_Event_Activate += new Microsoft.Office.Interop.Outlook.InspectorEvents_ActivateEventHandler(m_Insp_Activate);

                m_blnKilled = false;
                m_Startup = true;
            }
        }

        public int Key
        {
            get
            {
                return m_ID;
            }

            set
            {
                m_ID = value;
            }
        }

        public Outlook.MailItem MailItem
        {
            get
            {
                return m_Mail;
            }

            set
            {
                m_Mail = value;

                if (m_Mail != null)
                {
                    // hook up the Item.Close and Item.Send events
                    m_events = (Outlook.ItemEvents_Event)m_Mail;

                    m_events.Send += new Microsoft.Office.Interop.Outlook.ItemEvents_SendEventHandler(m_Mail_Send);

                    m_events.Close += new Microsoft.Office.Interop.Outlook.ItemEvents_CloseEventHandler(m_Mail_Close);
                }
            }
        }

        public Outlook.AppointmentItem AppointmentItem
        {
            get
            {
                return m_Appt;
            }

            set
            {
                m_Appt = value;

                if (m_Appt != null)
                {
                    // hook up the Item.Close and Item.Send events
                    m_ApptEvents = (Outlook.ItemEvents_Event)m_Appt;

                    m_ApptEvents.Open += new Microsoft.Office.Interop.Outlook.ItemEvents_OpenEventHandler(m_ApptEvents_Open);

                    m_ApptEvents.Close += new Microsoft.Office.Interop.Outlook.ItemEvents_CloseEventHandler(m_ApptEvents_Close);
                }
            }
        }

        void m_Insp_Activate()
        {
            if (m_Startup == true)
            {
                if (m_Mail !=null)
                {
                    switch(m_Mail.BodyFormat)
                    {
                        case Outlook.OlBodyFormat.olFormatHTML:
                            HTML = true;
                            PT = false;
                            RTF = false;
                            break;
                        case Outlook.OlBodyFormat.olFormatPlain:
                            HTML = false;
                            PT = true;
                            RTF = false;
                            break;
                        case Outlook.OlBodyFormat.olFormatRichText:
                            HTML = false;
                            PT = false;
                            RTF = true;
                            break;
                        default:
                        {
                            HTML = true;
                            PT = false;
                            RTF = false;
                            break;
                        }
                    }

                    if (m_Ribbon != null)
                    {
                        m_Ribbon.Invalidate();
                        m_Startup = false;
                    }
                }
            }
        }

        private void m_Insp_Close()
        {
            if (m_blnKilled == false)
            {
                m_blnKilled = true;

                // remove from the Inspector wrapper collection
                OutInsp killer = new OutInsp();
                killer.KillInsp(m_ID, m_WrapperClass);
                killer = null;

                m_WrapperClass = null;

                // release the Inspector.Close event handler
                m_InspClass.InspectorEvents_Event_Close -= new Microsoft.Office.Interop.Outlook.InspectorEvents_CloseEventHandler(m_Insp_Close);

                // release the Inspector Activate event handler
                m_InspClass.InspectorEvents_Event_Activate -= new Microsoft.Office.Interop.Outlook.InspectorEvents_ActivateEventHandler(m_Insp_Activate);

                if (m_Insp != null) { m_Insp = null; }
                if (m_InspClass != null) { m_InspClass = null; }

                if (m_Mail != null)
                {
                    if (m_events != null)
                    {
                        m_events.Send -= new Microsoft.Office.Interop.Outlook.ItemEvents_SendEventHandler(m_Mail_Send);
                        m_events.Close -= new Microsoft.Office.Interop.Outlook.ItemEvents_CloseEventHandler(m_Mail_Close);
                        m_events = null;
                    }
                    m_Mail = null;
                }

                if (m_Pane != null)
                {
                    m_Pane.VisibleStateChange -= new Office._CustomTaskPaneEvents_VisibleStateChangeEventHandler(m_Pane_VisibleStateChange);
                    m_Pane.DockPositionStateChange -= new Microsoft.Office.Core._CustomTaskPaneEvents_DockPositionStateChangeEventHandler(m_Pane_DockPositionStateChange);
                    m_Pane.Delete();
                    m_Pane = null;
                }


                if (m_Appt != null)
                {
                    if (m_ApptEvents != null)
                    {
                        m_ApptEvents.Open -= new Microsoft.Office.Interop.Outlook.ItemEvents_OpenEventHandler(m_ApptEvents_Open);
                        m_ApptEvents.Close -= new Microsoft.Office.Interop.Outlook.ItemEvents_CloseEventHandler(m_ApptEvents_Close);
                        m_ApptEvents = null;
                    }
                    m_Appt = null;
                }

                if (m_Region != null) { m_Region = null; }
                if (m_Ribbon != null) { m_Ribbon = null; }
            }
        }

        private void m_Mail_Close(ref bool Cancel)
        {
            Debug.WriteLine("Item closing");
        }

        private void m_Mail_Send(ref bool cancel)
        {
            Debug.WriteLine("MailItem_Send");
            //cancel = true;
        }

        void m_ApptEvents_Open(ref bool Cancel)
        {
            Debug.WriteLine("Appointment opening");
        }

        void m_ApptEvents_Close(ref bool Cancel)
        {
            Debug.WriteLine("Appointment closing");
        }

        void m_Pane_VisibleStateChange(Office.CustomTaskPane CustomTaskPaneInst)
        {
            Debug.WriteLine("Task Pane Visibility: " + CustomTaskPaneInst.Visible.ToString());
        }

        void m_Pane_DockPositionStateChange(Microsoft.Office.Core.CustomTaskPane CustomTaskPaneInst)
        {
            Debug.WriteLine("Task Pane Position Change: " + " " + CustomTaskPaneInst.DockPosition.ToString());
        }
    }
}